# Baidu

Baidu SEM Services
Baidu Ranking Services
Baidu Map Services

## Installation

Add this line to your application's Gemfile:

    gem 'baidu'

And then execute:

    $ bundle

Or install it yourself as:

    $ gem install baidu

## Acknowledged
camel命名法，用于request数据格式
snake命名法，用于response数据格式

## Rspec
先修改spec/spec_helper.rb

```ruby

$username = ''
$password = ''
$token = ''

```

## Usage

SEM

```ruby
require 'baidu'

$auth = Baidu::Auth.new
$auth.username = 'username'
$auth.password = 'password'
$auth.token = 'token'

ss = Baidu::SEM::SearchService.new
res = ss.getKeywordBySearch({:searchWord=>'word',:searchType=>0})
res = ss.getKeywordBySearch({:searchWord=>'word',:searchType=>0},true) #debug=true
```


##Documents


###RankingService


####方法


#####getPreview


Request: GetPreviewRequest

属性名             | 类型        |   意义    |   限制        | 说明
----------------|---------------|-------------|---------------|-----------------
keyWords         | List String     | 关键词字面 | 必填             |目前最多输入5个关键词，超过报错。
device             | int                  | 设备类型     | 必填 | 0:PC 目前只支持PC的推广实况，移动推广实况会于近期推出|
region  | int | 地域代码  |必填 | 目前支持二级地域，地域对照表详见《地域对照表》
page | int | 页码 | 选填|推广实况的页码，从0开始为第一页
display | int | 数据展现方式  | 必填 |0:html 该字段为预留字段，目前只支持HTML格式的数据返回方式

Response:GetPreviewResponse

属性名  | 类型 | 说明
---------|--------|----------
previewInfos  | List<PreviewInfo>  | 关键词的推广实况数据（html格式）

ResponseFormat:PreviewInfo

属性名 |  类型 | 说明 | 限制
---------|-------|-----|------
keyword | String | 关键词字面  |  -
data | String | 使用gzip进行压缩的推广实况的HTML数据， 解压缩之前请将用base64解码，然后gzip解压，解压后再使用utf-8编码转换为String，即为推广实况的实际HTML数据 | -

####
####区域代码

地域代码  地域名称

```
4085    潮州
4116    东莞
4090    佛山
4084    广州
4115    河源
4117    惠州
4082    江门
4083    揭阳
4086    茂名
4088    梅州
4089    清远
4091    汕头
4092    汕尾
4094    韶关
4093    深圳
4109    阳江
4111    云浮
4110    湛江
4114    肇庆
4112    中山
4113    珠海
5081    福州
5050    龙岩
5049    南平
5051    宁德
5048    莆田
5052    泉州
5066    三明
5070    厦门
5080    漳州
8493    白沙黎族自治县
8488    保亭黎族苗族自治县
8492    昌江黎族自治县
8487    澄迈县
8303    儋州
8484    定安县
8296    东方
8302    海口
8490    乐东黎族自治县
8491    临高县
8486    陵水黎族自治县
8297    琼海
8489    琼中黎族苗族自治县
8298    三亚
8485    屯昌县
8301    万宁
8299    文昌
8300    五指山
9128    安庆
9141    蚌埠
9143    亳州
9129    巢湖
9130    池州
9131    滁州
9140    阜阳
9142    合肥
9127    淮北
9133    淮南
9132    黄山
9135    六安
9134    马鞍山
9138    铜陵
9139    芜湖
9137    宿州
9136    宣城
10119    安顺
10124    毕节
10118    贵阳
10120    六盘水
10122    黔东南
10121    黔南
10123    黔西南
10125    铜仁
10126    遵义
11267    白银
11263    定西
11477    甘南
11257    嘉峪关
11256    金昌
11255    酒泉
11258    兰州
11261    临夏
11259    陇南
11260    平凉
11262    庆阳
11265    天水
11264    武威
11266    张掖
12108    百色
12104    北海
12478    崇左
12098    防城港
12096    贵港
12095    桂林
12106    河池
12107    贺州
12100    来宾
12101    柳州
12099    南宁
12102    钦州
12103    梧州
12105    玉林
13304    保定
13305    沧州
13306    承德
13330    邯郸
13332    衡水
13307    廊坊
13325    秦皇岛
13327    石家庄
13329    唐山
13326    邢台
13331    张家口
14309    安阳
14323    鹤壁
14476    济源
14308    焦作
14310    开封
14311    洛阳
14312    漯河
14315    南阳
14313    平顶山
14316    濮阳
14321    三门峡
14320    商丘
14317    新乡
14318    信阳
14319    许昌
14322    郑州
14324    周口
14314    驻马店
15342    大庆
15343    大兴安岭
15335    哈尔滨
15344    鹤岗
15345    黑河
15333    鸡西
15334    佳木斯
15336    牡丹江
15338    七台河
15337    齐齐哈尔
15340    双鸭山
15339    绥化
15341    伊春
16377    鄂州
16366    恩施
16349    黄冈
16348    黄石
16346    荆门
16347    荆州
16364    潜江
16368    神农架
16369    十堰
16367    随州
16373    天门
16371    武汉
16372    仙桃
16375    咸宁
16370    襄阳
16365    孝感
16376    宜昌
17351    常德
17353    郴州
17360    衡阳
17350    怀化
17354    娄底
17355    邵阳
17356    湘潭
17357    湘西
17359    益阳
17362    永州
17361    岳阳
17358    张家界
17352    长沙
17363    株洲
18039    白城
18042    白山
18038    吉林
18041    辽源
18043    四平
18044    松原
18045    通化
18047    延边
18040    长春
19054    常州
19053    淮安
19057    连云港
19055    南京
19056    南通
19059    苏州
19061    泰州
19062    无锡
19060    宿迁
19058    徐州
19063    盐城
19064    扬州
19065    镇江
20078    抚州
20077    赣州
20068    吉安
20069    景德镇
20067    九江
20072    南昌
20071    萍乡
20074    上饶
20073    新余
20075    宜春
20076    鹰潭
21151    鞍山
21145    本溪
21147    朝阳
21155    大连
21144    丹东
21152    抚顺
21150    阜新
21157    葫芦岛
21146    锦州
21148    辽阳
21149    盘锦
21153    沈阳
21154    铁岭
21156    营口
22159    阿拉善盟
22162    巴彦淖尔
22169    包头
22158    赤峰
22168    鄂尔多斯
22167    呼和浩特
22166    呼伦贝尔
22161    通辽
22164    乌海
22163    乌兰察布
22165    锡林郭勒盟
22160    兴安盟
23170    固原
23171    石嘴山
23172    吴忠
23174    银川
23173    中卫
24496    果洛
24494    海北
24176    海东
24479    海南
24177    海西
24495    黄南
24175    西宁
24178    玉树
25223    滨州
25200    德州
25220    东营
25222    菏泽
25196    济南
25197    济宁
25198    莱芜
25199    聊城
25201    临沂
25202    青岛
25203    日照
25208    泰安
25218    威海
25204    潍坊
25219    烟台
25221    枣庄
25207    淄博
26217    大同
26205    晋城
26206    晋中
26211    临汾
26210    吕梁
26213    朔州
26214    太原
26212    忻州
26215    阳泉
26216    运城
26209    长治
27240    安康
27239    宝鸡
27248    汉中
27241    商洛
27242    铜川
27243    渭南
27244    西安
27245    咸阳
27246    延安
27249    榆林
28252    阿坝
28247    巴中
28226    成都
28250    达州
28232    德阳
28236    甘孜
28224    广安
28225    广元
28233    乐山
28228    凉山
28234    泸州
28227    眉山
28229    绵阳
28231    南充
28235    内江
28230    攀枝花
28237    遂宁
28251    雅安
28254    宜宾
28238    资阳
28253    自贡
29498    阿里
29480    昌都
29269    拉萨
29270    林芝
29268    那曲
29271    日喀则
29497    山南
30185    阿克苏
30499    阿拉尔
30182    阿勒泰
30191    巴音郭楞
30180    博尔塔拉
30181    昌吉
30179    哈密
30195    和田
30183    喀什
30184    克拉玛依
30186    克孜勒苏柯尔克孜
30187    石河子
30188    塔城
30500    图木舒克
30190    吐鲁番
30192    乌鲁木齐
30189    五家渠
30193    伊犁
31289    保山
31283    楚雄
31292    大理
31286    德宏
31482    迪庆
31293    红河
31284    昆明
31285    丽江
31287    临沧
31481    怒江
31290    普洱
31288    曲靖
31291    文山
31483    西双版纳
31295    玉溪
31294    昭通
32280    杭州
32282    湖州
32273    嘉兴
32272    金华
32275    丽水
32276    宁波
32274    衢州
32277    绍兴
32279    台州
32278    温州
32281    舟山
```

####错误代码

```
90191801=The request keyword number is zero
90191802=The request keyword number is more than maximum
90191803=The request device code is neither 0(PC) nor 1(MOBILE)
90191804=The request display code is neither 0(HTML) nor 1(Structure)
90191805=The request page number is invalid
90191806=The request region code is invalid
90191807=The Server is too busy to response, please try again later
90191808=Server internal error, please check your request and try again later.
```

## Contributing

1. Fork it
2. Create your feature branch (`git checkout -b my-new-feature`)
3. Commit your changes (`git commit -am 'Add some feature'`)
4. Push to the branch (`git push origin my-new-feature`)
5. Create new Pull Request